Vytvoří nebo aktualizuje klíč serveru.
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Sql/servers/{serverName}/keys/{keyName}?api-version=2025-01-01
Parametry identifikátoru URI
| Name |
V |
Vyžadováno |
Typ |
Description |
|
keyName
|
path |
True
|
string
|
Název klíče serveru, který se má načíst.
|
|
resourceGroupName
|
path |
True
|
string
minLength: 1 maxLength: 90
|
Název skupiny prostředků. Název nerozlišuje malá a velká písmena.
|
|
serverName
|
path |
True
|
string
|
Název serveru.
|
|
subscriptionId
|
path |
True
|
string
(uuid)
|
ID cílového předplatného. Hodnota musí být UUID.
|
|
api-version
|
query |
True
|
string
minLength: 1
|
Verze rozhraní API, která se má použít pro tuto operaci.
|
Text požadavku
| Name |
Vyžadováno |
Typ |
Description |
|
properties.serverKeyType
|
True
|
ServerKeyType
|
Typ klíče serveru, jako je ServiceManaged, AzureKeyVault.
|
|
properties.uri
|
|
string
|
Identifikátor URI klíče serveru. Pokud je ServerKeyType AzureKeyVault, je potřeba identifikátor URI. Identifikátor URI AKV musí být v tomto formátu: 'https://YourVaultName.vault.azure.net/keys/YourKeyName/YourKeyVersion' nebo může být 'https://YourVaultName.vault.azure.net/keys/YourKeyName'
|
Odpovědi
| Name |
Typ |
Description |
|
200 OK
|
ServerKey
|
Operace aktualizace zdroje 'ServerKey' byla úspěšná
|
|
201 Created
|
ServerKey
|
Operace vytvoření zdroje 'ServerKey' uspěla
Hlavičky
- Location: string
- Retry-After: integer
|
|
202 Accepted
|
|
Operace prostředku byla přijata.
Hlavičky
- Location: string
- Retry-After: integer
|
|
Other Status Codes
|
ErrorResponse
|
Neočekávaná chybová odpověď
|
Zabezpečení
azure_auth
Azure Active Directory OAuth2 Flow.
Typ:
oauth2
Tok:
implicit
URL autorizace:
https://login.microsoftonline.com/common/oauth2/authorize
Rozsahy
| Name |
Description |
|
user_impersonation
|
zosobnění uživatelského účtu
|
Příklady
Creates or updates a server key
Ukázkový požadavek
PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901?api-version=2025-01-01
{
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"
}
}
import com.azure.resourcemanager.sql.fluent.models.ServerKeyInner;
import com.azure.resourcemanager.sql.models.ServerKeyType;
/**
* Samples for ServerKeys CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
*/
/**
* Sample code: Creates or updates a server key.
*
* @param manager Entry point to SqlServerManager.
*/
public static void createsOrUpdatesAServerKey(com.azure.resourcemanager.sql.SqlServerManager manager) {
manager.serviceClient().getServerKeys().createOrUpdate("sqlcrudtest-7398", "sqlcrudtest-4645",
"someVault_someKey_01234567890123456789012345678901",
new ServerKeyInner().withServerKeyType(ServerKeyType.AZURE_KEY_VAULT)
.withUri("https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"),
com.azure.core.util.Context.NONE);
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.sql import SqlManagementClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-sql
# USAGE
python server_key_create_or_update.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = SqlManagementClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.server_keys.begin_create_or_update(
resource_group_name="sqlcrudtest-7398",
server_name="sqlcrudtest-4645",
key_name="someVault_someKey_01234567890123456789012345678901",
parameters={
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901",
}
},
).result()
print(response)
# x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { SqlManagementClient } = require("@azure/arm-sql");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a server key.
*
* @summary creates or updates a server key.
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdate.json
*/
async function createsOrUpdatesAServerKey() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-1111-2222-3333-444444444444";
const client = new SqlManagementClient(credential, subscriptionId);
const result = await client.serverKeys.createOrUpdate(
"sqlcrudtest-7398",
"sqlcrudtest-4645",
"someVault_someKey_01234567890123456789012345678901",
{
serverKeyType: "AzureKeyVault",
uri: "https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901",
},
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
using Azure;
using Azure.ResourceManager;
using System;
using System.Threading.Tasks;
using Azure.Core;
using Azure.Identity;
using Azure.ResourceManager.Sql.Models;
using Azure.ResourceManager.Sql;
// Generated from example definition: specification/sql/resource-manager/Microsoft.Sql/SQL/stable/2025-01-01/examples/ServerKeyCreateOrUpdate.json
// this example is just showing the usage of "ServerKeys_CreateOrUpdate" operation, for the dependent resources, they will have to be created separately.
// get your azure access token, for more details of how Azure SDK get your access token, please refer to https://learn.microsoft.com/en-us/dotnet/azure/sdk/authentication?tabs=command-line
TokenCredential cred = new DefaultAzureCredential();
// authenticate your client
ArmClient client = new ArmClient(cred);
// this example assumes you already have this SqlServerResource created on azure
// for more information of creating SqlServerResource, please refer to the document of SqlServerResource
string subscriptionId = "00000000-1111-2222-3333-444444444444";
string resourceGroupName = "sqlcrudtest-7398";
string serverName = "sqlcrudtest-4645";
ResourceIdentifier sqlServerResourceId = SqlServerResource.CreateResourceIdentifier(subscriptionId, resourceGroupName, serverName);
SqlServerResource sqlServer = client.GetSqlServerResource(sqlServerResourceId);
// get the collection of this SqlServerKeyResource
SqlServerKeyCollection collection = sqlServer.GetSqlServerKeys();
// invoke the operation
string keyName = "someVault_someKey_01234567890123456789012345678901";
SqlServerKeyData data = new SqlServerKeyData
{
ServerKeyType = SqlServerKeyType.AzureKeyVault,
Uri = new Uri("https://someVault.vault.azure.net/keys/someKey/01234567890123456789012345678901"),
};
ArmOperation<SqlServerKeyResource> lro = await collection.CreateOrUpdateAsync(WaitUntil.Completed, keyName, data);
SqlServerKeyResource result = lro.Value;
// the variable result is a resource, you could call other operations on this instance as well
// but just for demo, we get its data from this resource instance
SqlServerKeyData resourceData = result.Data;
// for demo we just print out the id
Console.WriteLine($"Succeeded on id: {resourceData.Id}");
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Ukázková odpověď
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
Creates or updates a server key with versionless key
Ukázkový požadavek
PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey?api-version=2025-01-01
{
"properties": {
"serverKeyType": "AzureKeyVault",
"uri": "https://someVault.vault.azure.net/keys/someKey"
}
}
import com.azure.resourcemanager.sql.fluent.models.ServerKeyInner;
import com.azure.resourcemanager.sql.models.ServerKeyType;
/**
* Samples for ServerKeys CreateOrUpdate.
*/
public final class Main {
/*
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
*/
/**
* Sample code: Creates or updates a server key with versionless key.
*
* @param manager Entry point to SqlServerManager.
*/
public static void
createsOrUpdatesAServerKeyWithVersionlessKey(com.azure.resourcemanager.sql.SqlServerManager manager) {
manager.serviceClient().getServerKeys().createOrUpdate("sqlcrudtest-7398", "sqlcrudtest-4645",
"someVault_someKey", new ServerKeyInner().withServerKeyType(ServerKeyType.AZURE_KEY_VAULT)
.withUri("https://someVault.vault.azure.net/keys/someKey"),
com.azure.core.util.Context.NONE);
}
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
from azure.identity import DefaultAzureCredential
from azure.mgmt.sql import SqlManagementClient
"""
# PREREQUISITES
pip install azure-identity
pip install azure-mgmt-sql
# USAGE
python server_key_create_or_update_with_versionless_key.py
Before run the sample, please set the values of the client ID, tenant ID and client secret
of the AAD application as environment variables: AZURE_CLIENT_ID, AZURE_TENANT_ID,
AZURE_CLIENT_SECRET. For more info about how to get the value, please see:
https://docs.microsoft.com/azure/active-directory/develop/howto-create-service-principal-portal
"""
def main():
client = SqlManagementClient(
credential=DefaultAzureCredential(),
subscription_id="SUBSCRIPTION_ID",
)
response = client.server_keys.begin_create_or_update(
resource_group_name="sqlcrudtest-7398",
server_name="sqlcrudtest-4645",
key_name="someVault_someKey",
parameters={
"properties": {"serverKeyType": "AzureKeyVault", "uri": "https://someVault.vault.azure.net/keys/someKey"}
},
).result()
print(response)
# x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
if __name__ == "__main__":
main()
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
const { SqlManagementClient } = require("@azure/arm-sql");
const { DefaultAzureCredential } = require("@azure/identity");
/**
* This sample demonstrates how to creates or updates a server key.
*
* @summary creates or updates a server key.
* x-ms-original-file: 2025-01-01/ServerKeyCreateOrUpdateWithVersionlessKey.json
*/
async function createsOrUpdatesAServerKeyWithVersionlessKey() {
const credential = new DefaultAzureCredential();
const subscriptionId = "00000000-1111-2222-3333-444444444444";
const client = new SqlManagementClient(credential, subscriptionId);
const result = await client.serverKeys.createOrUpdate(
"sqlcrudtest-7398",
"sqlcrudtest-4645",
"someVault_someKey",
{ serverKeyType: "AzureKeyVault", uri: "https://someVault.vault.azure.net/keys/someKey" },
);
console.log(result);
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
using Azure;
using Azure.ResourceManager;
using System;
using System.Threading.Tasks;
using Azure.Core;
using Azure.Identity;
using Azure.ResourceManager.Sql.Models;
using Azure.ResourceManager.Sql;
// Generated from example definition: specification/sql/resource-manager/Microsoft.Sql/SQL/stable/2025-01-01/examples/ServerKeyCreateOrUpdateWithVersionlessKey.json
// this example is just showing the usage of "ServerKeys_CreateOrUpdate" operation, for the dependent resources, they will have to be created separately.
// get your azure access token, for more details of how Azure SDK get your access token, please refer to https://learn.microsoft.com/en-us/dotnet/azure/sdk/authentication?tabs=command-line
TokenCredential cred = new DefaultAzureCredential();
// authenticate your client
ArmClient client = new ArmClient(cred);
// this example assumes you already have this SqlServerResource created on azure
// for more information of creating SqlServerResource, please refer to the document of SqlServerResource
string subscriptionId = "00000000-1111-2222-3333-444444444444";
string resourceGroupName = "sqlcrudtest-7398";
string serverName = "sqlcrudtest-4645";
ResourceIdentifier sqlServerResourceId = SqlServerResource.CreateResourceIdentifier(subscriptionId, resourceGroupName, serverName);
SqlServerResource sqlServer = client.GetSqlServerResource(sqlServerResourceId);
// get the collection of this SqlServerKeyResource
SqlServerKeyCollection collection = sqlServer.GetSqlServerKeys();
// invoke the operation
string keyName = "someVault_someKey";
SqlServerKeyData data = new SqlServerKeyData
{
ServerKeyType = SqlServerKeyType.AzureKeyVault,
Uri = new Uri("https://someVault.vault.azure.net/keys/someKey"),
};
ArmOperation<SqlServerKeyResource> lro = await collection.CreateOrUpdateAsync(WaitUntil.Completed, keyName, data);
SqlServerKeyResource result = lro.Value;
// the variable result is a resource, you could call other operations on this instance as well
// but just for demo, we get its data from this resource instance
SqlServerKeyData resourceData = result.Data;
// for demo we just print out the id
Console.WriteLine($"Succeeded on id: {resourceData.Id}");
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Ukázková odpověď
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
{
"name": "sqlcrudtest-4645",
"type": "Microsoft.Sql/servers/keys",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/sqlcrudtest-7398/providers/Microsoft.Sql/servers/sqlcrudtest-4645/keys/someVault_someKey_01234567890123456789012345678901",
"kind": "azurekeyvault",
"location": "Japan East",
"properties": {
"serverKeyType": "AzureKeyVault",
"creationDate": "2024-11-15T00:00:00Z",
"thumbprint": "00112233445566778899AABBCCDDEEFFAABBCCDD"
}
}
Definice
createdByType
Výčet
Typ identity, která prostředek vytvořila.
| Hodnota |
Description |
|
User
|
|
|
Application
|
|
|
ManagedIdentity
|
|
|
Key
|
|
ErrorAdditionalInfo
Objekt
Další informace o chybě správy prostředků
| Name |
Typ |
Description |
|
info
|
object
|
Další informace.
|
|
type
|
string
|
Další typ informací.
|
ErrorDetail
Objekt
Podrobnosti o chybě.
| Name |
Typ |
Description |
|
additionalInfo
|
ErrorAdditionalInfo[]
|
Další informace o chybě.
|
|
code
|
string
|
Kód chyby.
|
|
details
|
ErrorDetail[]
|
Podrobnosti o chybě.
|
|
message
|
string
|
Chybová zpráva.
|
|
target
|
string
|
Cíl chyby.
|
ErrorResponse
Objekt
Chybová odpověď
ServerKey
Objekt
Klíč serveru.
| Name |
Typ |
Description |
|
id
|
string
(arm-id)
|
Plně kvalifikované ID prostředku pro prostředek. Např. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
|
|
kind
|
string
|
Druh ochrany šifrování. Toto jsou metadata používaná pro Azure portálový zážitek.
|
|
location
|
string
|
Umístění prostředku
|
|
name
|
string
|
Název prostředku
|
|
properties.autoRotationEnabled
|
boolean
|
Příznak výslovného souhlasu s automatickým otáčením klíčů Buď pravda, nebo nepravda.
|
|
properties.creationDate
|
string
(date-time)
|
Datum vytvoření klíče serveru.
|
|
properties.keyVersion
|
string
|
Verze klíče serveru.
|
|
properties.serverKeyType
|
ServerKeyType
|
Typ klíče serveru, jako je ServiceManaged, AzureKeyVault.
|
|
properties.subregion
|
string
|
Podregion klíče serveru.
|
|
properties.thumbprint
|
string
|
Kryptografický otisk klíče serveru.
|
|
properties.uri
|
string
|
Identifikátor URI klíče serveru. Pokud je ServerKeyType AzureKeyVault, je potřeba identifikátor URI. Identifikátor URI AKV musí být v tomto formátu: 'https://YourVaultName.vault.azure.net/keys/YourKeyName/YourKeyVersion' nebo může být 'https://YourVaultName.vault.azure.net/keys/YourKeyName'
|
|
systemData
|
systemData
|
Azure Resource Manager metadata obsahující informace createdBy a modifiedBy.
|
|
type
|
string
|
Typ prostředku. Například "Microsoft. Compute/virtualMachines" nebo "Microsoft. Úložiště/úložištěÚčty"
|
ServerKeyType
Výčet
Typ ochrany šifrování, jako je ServiceManaged, AzureKeyVault.
| Hodnota |
Description |
|
ServiceManaged
|
ServiceManaged
|
|
AzureKeyVault
|
Trezor klíčů Azure.
|
systemData
Objekt
Metadata týkající se vytvoření a poslední změny prostředku.
| Name |
Typ |
Description |
|
createdAt
|
string
(date-time)
|
Časové razítko vytvoření prostředku (UTC).
|
|
createdBy
|
string
|
Identita, která prostředek vytvořila.
|
|
createdByType
|
createdByType
|
Typ identity, která prostředek vytvořila.
|
|
lastModifiedAt
|
string
(date-time)
|
Časové razítko poslední změny zdroje (UTC)
|
|
lastModifiedBy
|
string
|
Identita, která naposledy změnila prostředek.
|
|
lastModifiedByType
|
createdByType
|
Typ identity, která naposledy změnila prostředek.
|